/*
 * Copyright (C) 2002-2004 Red Hat Inc. All Rights Reserved.
 *
 * The contents of this file are subject to the CCM Public
 * License (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the
 * License at http://www.redhat.com/licenses/ccmpl.html.
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language
 * governing rights and limitations under the License.
 *
 */
package com.arsdigita.dbinvariants;

import com.arsdigita.tools.junit.framework.BaseTestCase;

import com.arsdigita.persistence.DataQuery;
import com.arsdigita.persistence.SessionManager;

import com.arsdigita.util.Assert;

import java.util.ArrayList;
import java.util.List;

public class DbInvariantTest extends BaseTestCase {

    public DbInvariantTest(String name) {
        super(name);
    }

    /**
     * Insure that indices exist for all foreign keys.
     */
    public void testForeignKeyIndicesExist() {
        DataQuery dq = SessionManager.getSession().retrieveQuery("dbinvariants.ForeignKeyIndices");
        List actual = new ArrayList();
        while ( dq.next() ) {
            actual.add(dq.get("tableName") + "." + dq.get("columnName"));
        }
        dq.close();
        List expected = new ArrayList();

        assertEquals("Unindexed foreign keys", expected, actual);
    }
}
